<?php
/*!
	@file
		Classes for PDO support
*/

require_once("db_common.php");
/*! Wrapper around PDO connection
**/
class PDODBWrapper extends DBWrapper{
	private $last_result;//!< store result or last operation
	function query($sql,$result=false){ 
		//may cause problems for tree
		if ($this->last_result)
			$this->last_result->closeCursor();
		
		if (is_object($sql))
			$sql=$sql->sql();
		
		$this->logger->log("Exec SQL: ",$sql);
		$this->last_result=$res=$this->db->query($sql);
		if (!$res){
			$error = $this->db->errorInfo();
			$this->logger->log("PDO error: ",$error[2]);
			return false;
		}
		if ($result===false)
			return $res;
		else 
			return $res->fetchColumn($result);
	}	
	function escape($str){
		$res=$this->db->quote($str);
		if ($res===false) //not supported by pdo driver
			return str_replace("'","''",$str); 
		return substr($res,1,-1);
	}	
	function get_data_array($res){
		return $res->fetch(PDO::FETCH_NUM);
	}
	function get_data_named($res){
		return $res->fetch(PDO::FETCH_ASSOC);
	}
	function get_id(){
		return $this->db->lastInsertId();
	}
	function count($res){
		return $res->rowCount();	
	}
}
/*! Generator of select queries for PDO connection
**/	
class DBQueryPDO extends DBQuery{
}

?>